/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
 Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using System.Collections.Generic;using UnityEngine;namespace PluginIdea{    [ExecuteInEditMode]    [RequireComponent(typeof(MeshRenderer))]    [RequireComponent(typeof(MeshFilter))]    public class LensFlareMono : MonoBehaviour    {        [SerializeField, HideInInspector]        MeshRenderer m_MeshRenderer;        [SerializeField, HideInInspector]        MeshFilter m_MeshFilter;        [SerializeField]        Light m_Light;        [Header("Global Settings")]        public float OcclusionRadius = 1.0f;        public float NearFadeStartDistance = 1.0f;        public float NearFadeEndDistance = 3.0f;        public float FarFadeStartDistance = 10.0f;        public float FarFadeEndDistance = 50.0f;        public float Alpha = 1f;        public List<FlareSettings> Flares;        private bool isInitied;        private LensHalo ower;        private void Awake()        {            if (m_MeshFilter == null)                m_MeshFilter = GetComponent<MeshFilter>();            if (m_MeshRenderer == null)                m_MeshRenderer = GetComponent<MeshRenderer>();            m_Light = GetComponent<Light>();            m_MeshFilter.hideFlags = HideFlags.None;            m_MeshRenderer.hideFlags = HideFlags.None;        }        public void Init(LensHalo ower)        {            this.ower = ower;            if (Flares == null)            {                Flares = new List<FlareSettings>();                Shader shader = ower.GetShaderByName("PluginIdea/LensFlare");                Flares.Add(new FlareSettings()                {                    RayPosition = 0.09f,                    Material = new Material(shader),                    Size = new Vector2(0.1f, 0.1f),                    MultiplyByLightColor = true,                    Rotation = 0,                    AutoRotate = true                });                Flares.Add(new FlareSettings()                {                    RayPosition = 0.17f,                    Size = new Vector2(0.2f, 0.2f),                    Material = new Material(shader),                    MultiplyByLightColor = true,                    Rotation = 57,                    AutoRotate = true                });                Flares.Add(new FlareSettings()                {                    RayPosition = 0.64f,                    Size = new Vector2(0.3f, 0.3f),                    Material = new Material(shader),                    MultiplyByLightColor = true,                    Rotation = 0,                    AutoRotate = true                });                Flares.Add(new FlareSettings()                {                    RayPosition = 0.54f,                    Size = new Vector2(0.3f, 0.3f),                    Material = new Material(shader),                    MultiplyByLightColor = true,                    Rotation = 0,                    AutoRotate = true                });                Flares.Add(new FlareSettings()                {                    RayPosition = 1.18f,                    Size = new Vector2(0.4f, 0.4f),                    Material = new Material(shader),                    MultiplyByLightColor = true,                    Rotation = 57,                    AutoRotate = true                });                Flares.Add(new FlareSettings()                {                    RayPosition = 2.06f,                    Size = new Vector2(3.13f, 3.13f),                    Material = new Material(shader),                    MultiplyByLightColor = true,                    Rotation = 0,                    AutoRotate = true                });                Flares.Add(new FlareSettings()                {                    RayPosition = 0.54f,                    Size = new Vector2(0.3f, 0.3f),                    Material = new Material(shader),                    MultiplyByLightColor = true,                    Rotation = 0,                    AutoRotate = true                });                Flares.Add(new FlareSettings()                {                    RayPosition = 0.54f,                    Size = new Vector2(0.3f, 0.3f),                    Material = new Material(shader),                    MultiplyByLightColor = true,                    Rotation = 0,                    AutoRotate = true                });            }            m_MeshFilter.sharedMesh = InitMesh();            UpdateMaterials();            UpdateGeometry();            isInitied = true;        }        public void SetFlareSize(int index, float size)        {            Flares[index].Size = new Vector2(size, size);        }        public void SetFlarePos(int index, float pos)        {            Flares[index].RayPosition = pos;        }        public void SetFlareIntersityMul(int index, float inten)        {            Flares[index].intensityMul = inten;        }        public void SetFlareAlphaMul(int index, float alphaMul)        {            Flares[index].alphaMul = alphaMul;        }        public void SetFlareColor(int index, Color color)        {            Flares[index].Color = color;        }        public void SetFlareRotation(int index, float rot)        {            Flares[index].Rotation = rot;        }        public void SetIsAutoRotate(int index, bool autoRotate)        {            Flares[index].AutoRotate = autoRotate;        }        public void SetIsMultiplyByLightColor(int index, bool isMul)        {            Flares[index].MultiplyByLightColor = isMul;        }        public void SetFlareTexture(int index, Texture tex)        {            Flares[index].Material.mainTexture = tex;        }        void Update()        {            if (isInitied)            {                UpdateVaryingAttributes();            }        }        Mesh InitMesh()        {            Mesh m = new Mesh();                                    m.MarkDynamic();            return m;        }        void UpdateMaterials()        {            Material[] mats = new Material[Flares.Count];            int i = 0;            foreach (FlareSettings f in Flares)            {                mats[i] = f.Material;                i++;            }            m_MeshRenderer.sharedMaterials = mats;        }        void UpdateGeometry()        {            Mesh m = m_MeshFilter.sharedMesh;                        List<Vector3> vertices = new List<Vector3>();            foreach (FlareSettings s in Flares)            {                vertices.Add(new Vector3(-1, -1, 0));                vertices.Add(new Vector3(1, -1, 0));                vertices.Add(new Vector3(1, 1, 0));                vertices.Add(new Vector3(-1, 1, 0));            }            m.SetVertices(vertices);                        List<Vector2> uvs = new List<Vector2>();            foreach (FlareSettings s in Flares)            {                uvs.Add(new Vector2(0, 1));                uvs.Add(new Vector2(1, 1));                uvs.Add(new Vector2(1, 0));                uvs.Add(new Vector2(0, 0));            }            m.SetUVs(0, uvs);                                    m.SetColors(GetLensFlareColor());            m.SetUVs(1, GetLensFlareData());            m.SetUVs(2, GetWorldPositionAndRadius());            m.SetUVs(3, GetDistanceFadeData());            m.subMeshCount = Flares.Count;                        for (int i = 0; i < Flares.Count; i++)            {                int[] tris = new int[6];                tris[0] = (i * 4) + 0;                tris[1] = (i * 4) + 1;                tris[2] = (i * 4) + 2;                tris[3] = (i * 4) + 2;                tris[4] = (i * 4) + 3;                tris[5] = (i * 4) + 0;                m.SetTriangles(tris, i);            }            Bounds b = m.bounds;            b.extents = new Vector3(OcclusionRadius, OcclusionRadius, OcclusionRadius);            m.bounds = b;            m.UploadMeshData(false);        }        void UpdateVaryingAttributes()        {            Mesh m = m_MeshFilter.sharedMesh;                        m.SetColors(GetLensFlareColor());            m.SetUVs(1, GetLensFlareData());            m.SetUVs(2, GetWorldPositionAndRadius());            m.SetUVs(3, GetDistanceFadeData());            foreach (var item in Flares)            {                item.Material.SetFloat("_Alpha", Alpha);            }            Bounds b = m.bounds;            b.extents = new Vector3(OcclusionRadius, OcclusionRadius, OcclusionRadius);            m.bounds = b;            m.name = "LensFlare (" + gameObject.name + ")";        }        List<Color> GetLensFlareColor()        {            List<Color> colors = new List<Color>();            foreach (FlareSettings s in Flares)            {                Color c = (s.MultiplyByLightColor && m_Light != null) ? s.Color * m_Light.color * m_Light.intensity * s.intensityMul * s.alphaMul : s.Color;                colors.Add(c);                colors.Add(c);                colors.Add(c);                colors.Add(c);            }            return colors;        }        List<Vector4> GetLensFlareData()        {            List<Vector4> lfData = new List<Vector4>();            foreach (FlareSettings s in Flares)            {                Vector4 data = new Vector4(s.RayPosition, s.AutoRotate ? -1 : Mathf.Abs(s.Rotation), s.Size.x, s.Size.y);                lfData.Add(data);                lfData.Add(data);                lfData.Add(data);                lfData.Add(data);            }            return lfData;        }        List<Vector4> GetDistanceFadeData()        {            List<Vector4> fadeData = new List<Vector4>();            foreach (FlareSettings s in Flares)            {                Vector4 data = new Vector4(NearFadeStartDistance, NearFadeEndDistance, FarFadeStartDistance, FarFadeEndDistance);                fadeData.Add(data);                fadeData.Add(data);                fadeData.Add(data);                fadeData.Add(data);            }            return fadeData;        }        List<Vector4> GetWorldPositionAndRadius()        {            List<Vector4> worldPos = new List<Vector4>();            Vector3 pos = transform.position;            Vector4 value = new Vector4(pos.x, pos.y, pos.z, OcclusionRadius);            foreach (FlareSettings s in Flares)            {                worldPos.Add(value);                worldPos.Add(value);                worldPos.Add(value);                worldPos.Add(value);            }            return worldPos;        }        [System.Serializable]        public class FlareSettings        {            public float RayPosition;            public Material Material;            [ColorUsage(true, true)]            public Color Color = Color.white;            public bool MultiplyByLightColor = true;            public Vector2 Size;            public float Rotation;            public bool AutoRotate = true;            public float OccludedSizeScale = 0;            public float intensityMul = 1;            public float alphaMul = 1;        }    }}